## org.exist.xquery
Class JavaCall

    java.lang.Object
      org.exist.xquery.AbstractExpression
          org.exist.xquery.PathExpr
              org.exist.xquery.Function
                  org.exist.xquery.JavaCall

All Implemented Interfaces:
  CompiledExpression, CompiledXQuery, Expression

public class JavaCall
extends Function

A special function call to a Java method or constructor. This class handles all function calls who's namespace URI starts with "java:".

Author:
  Wolfgang Meier (wolfgang@exist-db.org)

Field Summary

Fields inherited from class org.exist.xquery.Function
`BUILTIN_FUNCTION_NS`

Fields inherited from interface org.exist.xquery.Expression
`DOT_TEST, EXPRESSION_ID_INVALID, IGNORE_CONTEXT, IN_PREDICATE, IN_UPDATE, IN_WHERE_CLAUSE, NO_CONTEXT_ID, SINGLE_STEP_EXECUTION`

Constructor Summary
`JavaCall(XQueryContext context, QName qname)`

Method Summary
`void` `analyze(AnalyzeContextInfo contextInfo)` Statically analyze the expression and its subexpressions.
`Sequence` `eval(Sequence contextSequence, Item contextItem)` Evaluate the expression represented by this object.
`int` `getCardinality()` The default cardinality is `Cardinality.EXACTLY_ONE`.
`QName` `getName()` Return the name of this function.
`int` `returnsType()` The static return type of the expression.
`void` `setArguments(java.util.List arguments)` Set the (static) arguments for this function from a list of expressions.

Methods inherited from class org.exist.xquery.Function
`createFunction, dump, getArgument, getArgumentCount, getArguments, getASTNode, getDependencies, getParent, getSignature, isCalledAs, setASTNode, setParent, setPrimaryAxis, toString`

Methods inherited from class org.exist.xquery.PathExpr
`accept, add, add, addPath, addPredicate, dump, getContext, getDocumentSet, getExpression, getLastExpression, getLength, getLiteralValue, getSource, isValid, replaceLastExpression, reset, resetState, setContext, setSource`

Methods inherited from class org.exist.xquery.AbstractExpression
`eval, getContextDocSet, getContextId, getExpressionId, setContextDocSet`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface org.exist.xquery.CompiledXQuery
`eval`

Constructor Detail

### JavaCall

    public JavaCall(XQueryContext context,
                    QName qname)
             throws XPathException

Parameters:
  `context` -
  `qname` - the of the function

Method Detail

### getName

    public QName getName()

  Description copied from class: `Function`
  Return the name of this function.

  Overrides:
    `getName` in class `Function`
  Returns:
    name of this function

### getCardinality

    public int getCardinality()

  Description copied from class: `AbstractExpression`
  The default cardinality is `Cardinality.EXACTLY_ONE`.

  Specified by:
    `getCardinality` in interface `Expression`
  Overrides:
    `getCardinality` in class `Function`

### setArguments

    public void setArguments(java.util.List arguments)
                      throws XPathException

  Description copied from class: `Function`
  Set the (static) arguments for this function from a list of expressions. This will also check the type and cardinality of the passed argument expressions.

  Overrides:
    `setArguments` in class `Function`
  Parameters:
    `arguments` -
  Throws:
    `XPathException`

### analyze

    public void analyze(AnalyzeContextInfo contextInfo)
                 throws XPathException

  Description copied from interface: `Expression`
  Statically analyze the expression and its subexpressions. During the static analysis phase, the query engine can detect unknown variables and some type errors.

  Specified by:
    `analyze` in interface `Expression`
  Overrides:
    `analyze` in class `Function`
  Throws:
    `XPathException`

### eval

    public Sequence eval(Sequence contextSequence,
                         Item contextItem)
                  throws XPathException

  Description copied from interface: `Expression`
  Evaluate the expression represented by this object. Depending on the context in which this expression is executed, either the context sequence, the context item or both of them may be set. An implementing class should know how to handle this. The general contract is as follows: if the `Dependency.CONTEXT_ITEM` bit is set in the bit field returned by `Expression.getDependencies()`, the eval method will be called once for every item in the context sequence. The contextItem parameter will be set to the current item. Otherwise, the eval method will only be called once for the whole context sequence and contextItem will be null. eXist tries to process the entire context set in one, single step whenever possible. Thus, most classes only expect context to contain a list of nodes which represents the current context of the expression. The position() function in XPath is an example for an expression, which requires both, context sequence and context item to be set. The context sequence might be a node set, a sequence of atomic values or a single node or atomic value.

  Specified by:
    `eval` in interface `Expression`
  Specified by:
    `eval` in class `Function`
  Throws:
    `XPathException`

### returnsType

    public int returnsType()

  Description copied from interface: `Expression`
  The static return type of the expression. This method should return one of the type constants defined in class `Type`. If the return type cannot be determined statically, return Type.ITEM.

  Specified by:
    `returnsType` in interface `Expression`
  Overrides:
    `returnsType` in class `Function`

Copyright (C) Wolfgang Meier. All rights reserved.